/***************************************************************
 * Name:      wxiscanabout.cpp
 * Purpose:   Defines About Box Class.
 * Author:    Daniel Nell (daniel.nell@nellresearch.de)
 * Created:   2009-06-12
 * Copyright: Daniel Nell (www.nellresearch.de)
 * License:   GPL
 **************************************************************/

// Include precompiled headers.
#include "wx_pch.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(wxIScanAbout)
	#include <wx/string.h>
	#include <wx/intl.h>
	//*)
#endif
//(*InternalHeaders(wxIScanAbout)
#include <wx/button.h>
//*)

// wxWidgets headers
#include <wx/dialog.h>

// Private headers
#include "wxiscan.h"
#include "wxiscanabout.h"
#if __WXLUASCRIPT__
#   include "wxluascript.h"
#endif // __WXLUASCRIPT__


//(*IdInit(wxIScanAbout)
//*)


//////////////////////////////////////////////////////////
// Strings and other (global) constants
//
const wxString cstrAppName=            wxT( PRODUCT_NAME );
const wxString cstrAppDescription=     wxT( FILE_DESCRIPTION );
const wxString cstrVendor=             wxT( COMPANY_NAME );
const wxString cstrStatusCopyRight=    wxT( LEGAL_COPYRIGHT );
const wxString cstrVersionString=      wxString::Format( wxT( "%d.%d.%d (Build %d)" ),
                                                         AutoVersion::MAJOR,
                                                         AutoVersion::MINOR,
                                                         AutoVersion::BUILD,
                                                         AutoVersion::BUILDS_COUNT );
const wxString cstrWebSite=            wxT( WEB_SITE );
const wxString cstrWxVersionString=    wxVERSION_STRING;
#if __WXLUASCRIPT__
const wxString cstrLuaVersion=         wxT( LUA_VERSION );
#endif // __WXLUASCRIPT__


//////////////////////////////////////////////////////////
// Class wxIScanAbout
//
// Event table
//
BEGIN_EVENT_TABLE( wxIScanAbout, wxDialog )
	//(*EventTable(wxIScanAbout)
	//*)
END_EVENT_TABLE()

// Standard constructor.
//
wxIScanAbout::wxIScanAbout( wxWindow* parent, wxWindowID id )
{
	//(*Initialize(wxIScanAbout)
	wxFlexGridSizer* FlexGridSizer1;
	wxLinkInBrowserHtmlWindow* poHtmlWindow;
	wxStdDialogButtonSizer* poStdDialogButtonSizer;

	Create(parent, id, _("About"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("id"));
	SetClientSize(wxSize(460,510));
	FlexGridSizer1 = new wxFlexGridSizer(2, 1, 0, 0);
	poHtmlWindow = new wxLinkInBrowserHtmlWindow(this, wxID_ANY, wxDefaultPosition, wxSize(450,460), wxHW_SCROLLBAR_AUTO, _T("wxID_ANY"));
	FlexGridSizer1->Add(poHtmlWindow, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	poStdDialogButtonSizer = new wxStdDialogButtonSizer();
	poStdDialogButtonSizer->AddButton(new wxButton(this, wxID_OK, wxEmptyString));
	poStdDialogButtonSizer->Realize();
	FlexGridSizer1->Add(poStdDialogButtonSizer, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	SetSizer(FlexGridSizer1);
	Layout();
	Center();
	//*)

	wxString strHtml= wxString::Format( wxT( "<html>"
                                               "<head>"
                                                 "<title>%s - About</title>"
                                               "</head>"
                                               "<body bgcolor=#FAF0E6>"
                                                 "<div>"
                                                   "<h3 align=\"center\">"
                                                        "%s"
                                                        "<img src=\"http://%s/pictures/nellresearch.png\">"
                                                        "%s"
#if __DEBUG__
                                                        " DEBUG"
#endif // __DEBUG__
                                                   "</h3>"
                                                   "<p align=\"center\"><em>%s</em></p>"
                                                   "<p align=\"center\">"

                                                     "<a href=\"http://%s\">%s</a>"
                                                   "</p>"
                                                   "<p align=\"center\">%s. All rights reserved.</p>"
                                                   "<p>This program is licensed under the terms of the "
                                                        "<a href=\"http://www.nellresearch.de/licenses/gpl.txt\">GPL</a>. "
                                                        "Some parts of the source code is licensed under the terms of the "
                                                        "<a href=\"http://www.nellresearch.de/licenses/wxl.txt\">wxWindows licence</a>. "
                                                        "Please refere to the individual source code file."
                                                   "</p>"
                                                   "<p>This program was written using:</p>"
                                                   "<ul>"
                                                     "<li><a href=\"http://www.wxwidgets.org\">%s</a> "
                                                        "published under the <a href=\"http://www.nellresearch.de/licenses/wxl.txt\">wxWindows licence</a></li>"
#if wxUSE_PDF
                                                     "<li><a href=\"http://poppler.freedesktop.org\">Poppler</a> "
                                                        "published under the <a href=\"http://www.nellresearch.de/licenses/gpl-2.0.txt\">GPLv2</a></li>"
#endif // wxUSE_PDF
#if __WXPDFDOC__
                                                     "<li><a href=\"http://wxcode.sourceforge.net\">wxPdfDocument</a> "
                                                        "published under the <a href=\"http://www.nellresearch.de/licenses/wxl.txt\">wxWindows licence</a></li>"
#endif // __WXPDFDOC__
#if __WXLUASCRIPT__
                                                     "<li><a href=\"http://www.lua.org/\">%s</a>"
                                                        " published under the <a href=\"http://www.lua.org/license.html\">MIT licence</a></li>"
#endif // __WXLUASCRIPT__
                                                   "</ul>"
                                                   "<p>"
                                                        "<a href=\"http://www.nellresearch.de/licenses/gpl.txt\">"
                                                            "<img src=\"http://www.nellresearch.de/licenses/gplv3-127x51.png\">"
                                                        "</a>"
                                                        "<a href=\"http://www.wxwidgets.org\">"
                                                            "<img src=\"http://www.wxwidgets.org/logo9.jpg\">"
                                                        "</a>"
                                                   "</p>"
                                                 "</div>"
                                               "</body>"
                                             "</html>" ),
                                        cstrAppName.c_str(),
                                        cstrAppName.c_str(), cstrWebSite.c_str(), cstrVersionString.c_str(),
                                        cstrAppDescription.c_str(),
                                        cstrWebSite.c_str(), cstrWebSite.c_str(),
                                        cstrStatusCopyRight.c_str(),
                                        cstrWxVersionString.c_str()
#if __WXLUASCRIPT__
                                        , cstrLuaVersion.c_str()
#endif // __WXLUASCRIPT__
                                      );
	poHtmlWindow->SetPage( strHtml );
	SetTitle( poHtmlWindow->GetOpenedPageTitle() );
}

// Virtual destructor.
//
wxIScanAbout::~wxIScanAbout()
{
	//(*Destroy(wxIScanAbout)
	//*)
}


//////////////////////////////////////////////////////////
// Class wxLinkInBrowserHtmlWindow
//
// Event table.
//
BEGIN_EVENT_TABLE( wxLinkInBrowserHtmlWindow, wxHtmlWindow )
    EVT_HTML_LINK_CLICKED( wxID_ANY, wxLinkInBrowserHtmlWindow::OnLinkClicked )
END_EVENT_TABLE()


//////////////////////////////////////////////////////////
// Doxygen main page definition
//
/*! \mainpage wxIScan
 *
 * \image html wxiscan.png
 *
 * \section readme Introduction and additional information from the readme.txt file
 *
 * \verbinclude readme.txt
 *
 *
 * \section roadmap Roadmap
 *
 * \verbinclude roadmap.txt
 *
 *
 * \section licence Licence Information
 *
 * \subsection gpl Licence of wxIScan
 *
 * The whole program is licensed under the terms of the GPL.
 *
 * \verbinclude license/gpl.txt
 *
 *
 * \subsection wxwidgetslicence wxWindows/wxWidgets Licence
 *
 * Some parts of the source code is licensed under the terms of the wxWindows licence
 * which is an extended version of the GPL. See source code for further information on
 * which part of it the wxWindows licence is applicable.
 *
 * \verbinclude license/wxl.txt
 *
 *
 * ...
 *
 */
